
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ContactsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.create(
            {
                id: data.id || undefined,
        
        contact_type: data.contact_type
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        role_title: data.role_title
        ||
        null
            ,
            
        phone: data.phone
        ||
        null
            ,
            
        email: data.email
        ||
        null
            ,
            
        fax: data.fax
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await contacts.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await contacts.setPayer( data.payer || null, {
            transaction,
        });
        
        await contacts.setLocation( data.location || null, {
            transaction,
        });
        

        

        

        return contacts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const contactsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                contact_type: item.contact_type
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                role_title: item.role_title
            ||
            null
            ,
            
                phone: item.phone
            ||
            null
            ,
            
                email: item.email
            ||
            null
            ,
            
                fax: item.fax
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const contacts = await db.contacts.bulkCreate(contactsData, { transaction });

        // For each item created, replace relation files
        

        return contacts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const contacts = await db.contacts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.contact_type !== undefined) updatePayload.contact_type = data.contact_type;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.role_title !== undefined) updatePayload.role_title = data.role_title;
        
        
        if (data.phone !== undefined) updatePayload.phone = data.phone;
        
        
        if (data.email !== undefined) updatePayload.email = data.email;
        
        
        if (data.fax !== undefined) updatePayload.fax = data.fax;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        updatePayload.updatedById = currentUser.id;

        await contacts.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await contacts.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.payer !== undefined) {
            await contacts.setPayer(
              
              data.payer,
              
              { transaction }
            );
        }
        
        if (data.location !== undefined) {
            await contacts.setLocation(
              
              data.location,
              
              { transaction }
            );
        }
        

        
        

        

        return contacts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of contacts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of contacts) {
                await record.destroy({transaction});
            }
        });


        return contacts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.findByPk(id, options);

        await contacts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await contacts.destroy({
            transaction
        });

        return contacts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.findOne(
            { where },
            { transaction },
        );

        if (!contacts) {
            return contacts;
        }

        const output = contacts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await contacts.getOrganization({
            transaction
        });
        
        
        output.payer = await contacts.getPayer({
            transaction
        });
        
        
        output.location = await contacts.getLocation({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.payers,
        as: 'payer',
        
        where: filter.payer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.payer.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.payer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.locations,
        as: 'location',
        
        where: filter.location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.location.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.role_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'role_title',
                        filter.role_title,
                    ),
                };
            }
            
            if (filter.phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'phone',
                        filter.phone,
                    ),
                };
            }
            
            if (filter.email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'email',
                        filter.email,
                    ),
                };
            }
            
            if (filter.fax) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'fax',
                        filter.fax,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.contact_type) {
                where = {
                    ...where,
                contact_type: filter.contact_type,
            };
            }
            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.contacts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'contacts',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.contacts.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

